﻿using Supercell.GUT.Logic.Message.Attributes;
using Supercell.GUT.Titan.Logic.Message;

namespace Supercell.GUT.Logic.Message.Account;

[VersionedMessage(20102)]
public class CreateAccountFailedMessage : VersionedMessage
{
    public int ErrorCode { get; set; }

    public CreateAccountFailedMessage() : base(0)
    {
        this.ErrorCode = 0;
    }

    public override void Encode()
    {
        base.Encode();

        this.ByteStream.WriteInt(this.ErrorCode);
    }

    public override void Decode()
    {
        base.Decode();

        this.ErrorCode = this.ByteStream.ReadInt();
    }

    public override int GetMessageType()
    {
        return 20102;
    }

    public override int GetServiceNodeType()
    {
        return 1;
    }
}
