﻿using Supercell.GUT.Logic.Message.Attributes;
using Supercell.GUT.Titan.Logic.Message;

namespace Supercell.GUT.Logic.Message.Account;

[VersionedMessage(20101)]
public class CreateAccountOkMessage : VersionedMessage
{
    public int AccountIdHigherInt { get; set; }
    public int AccountIdLowerInt { get; set; }
    public string? SessionKey { get; set; }

    public CreateAccountOkMessage() : base(0)
    {
        this.AccountIdHigherInt = 0;
        this.AccountIdLowerInt = 0;
        this.SessionKey = null;
    }

    public override void Encode()
    {
        base.Encode();

        this.ByteStream.WriteInt(this.AccountIdHigherInt);
        this.ByteStream.WriteInt(this.AccountIdLowerInt);
        this.ByteStream.WriteString(this.SessionKey);
    }

    public override void Decode()
    {
        base.Decode();

        this.AccountIdHigherInt = this.ByteStream.ReadInt();
        this.AccountIdLowerInt = this.ByteStream.ReadInt();
        this.SessionKey = this.ByteStream.ReadString();
    }

    public override int GetMessageType()
    {
        return 20101;
    }

    public override int GetServiceNodeType()
    {
        return 1;
    }

    public override void Destruct()
    {
        base.Destruct();

        this.AccountIdHigherInt = 0;
        this.AccountIdLowerInt = 0;
        this.SessionKey = null;
    }
}
