﻿using Supercell.GUT.Logic.Message.Attributes;
using Supercell.GUT.Titan.Logic.Message;

namespace Supercell.GUT.Logic.Message.Account;

[VersionedMessage(10200)]
public class CreateAvatarMessage : VersionedMessage
{
    public string? Name { get; set; }

    public CreateAvatarMessage() : base(0)
    {
        Name = null;
    }

    public override void Encode()
    {
        base.Encode();

        ByteStream.WriteString(Name);
    }

    public override void Decode()
    {
        base.Decode();

        Name = ByteStream.ReadString();
    }

    public override int GetMessageType()
    {
        return 10200;
    }

    public override int GetServiceNodeType()
    {
        return 1;
    }

    public override void Destruct()
    {
        base.Destruct();

        Name = null;
    }
}
