﻿using Supercell.GUT.Logic.Message.Attributes;
using Supercell.GUT.Titan.Logic.Message;

namespace Supercell.GUT.Logic.Message.Avatar;

[VersionedMessage(10204)]
public class BuyMessage : VersionedMessage
{
    public string? Item { get; set; }

    public BuyMessage() : base(0)
    {
        Item = string.Empty;
    }

    public override void Destruct()
    {
        base.Destruct();

        Item = string.Empty;
    }

    public override int GetMessageType()
    {
        return 10204;
    }

    public override int GetServiceNodeType()
    {
        return 3;
    }

    public override void Encode()
    {
        base.Encode();

        ByteStream.WriteString(Item);
    }

    public override void Decode()
    {
        base.Decode();

        Item = ByteStream.ReadString();
    }
}
