﻿using Supercell.GUT.Logic.Message.Attributes;
using Supercell.GUT.Titan.Logic.Message;

namespace Supercell.GUT.Logic.Message.Avatar;

[VersionedMessage(10201)]
public class SelectAvatarMessage : VersionedMessage
{
    public int AvatarIdHigherInt { get; set; }
    public int AvatarIdLowerInt { get; set; }

    public SelectAvatarMessage() : base(0)
    {
        AvatarIdHigherInt = 0;
        AvatarIdLowerInt = 0;
    }

    public override void Encode()
    {
        base.Encode();

        ByteStream.WriteInt(AvatarIdHigherInt);
        ByteStream.WriteInt(AvatarIdLowerInt);
    }

    public override void Decode()
    {
        base.Decode();

        AvatarIdHigherInt = ByteStream.ReadInt();
        AvatarIdLowerInt = ByteStream.ReadInt();
    }

    public override int GetMessageType()
    {
        return 10201;
    }

    public override int GetServiceNodeType()
    {
        return 3;
    }

    public override void Destruct()
    {
        base.Destruct();

        AvatarIdHigherInt = 0;
        AvatarIdLowerInt = 0;
    }
}
