﻿using Supercell.GUT.Logic.Message.Attributes;
using Supercell.GUT.Titan.Logic.Message;

namespace Supercell.GUT.Logic.Message.Avatar;

[VersionedMessage(10210)]
public class TutorialProgressUpdateMessage : VersionedMessage
{
    public int TutorialFlags { get; set; }

    public TutorialProgressUpdateMessage() : base(0)
    {
        TutorialFlags = 0;
    }

    public override void Destruct()
    {
        base.Destruct();

        TutorialFlags = 0;
    }

    public override void Encode()
    {
        base.Encode();

        ByteStream.WriteInt(TutorialFlags);
    }

    public override void Decode()
    {
        base.Decode();

        TutorialFlags = ByteStream.ReadInt();
    }

    public override int GetMessageType()
    {
        return 10210;
    }

    public override int GetServiceNodeType()
    {
        return 3;
    }
}
