﻿using Supercell.GUT.Logic.Game;
using Supercell.GUT.Logic.Message.Attributes;
using Supercell.GUT.Titan.Logic.Message;

namespace Supercell.GUT.Logic.Message.Account;

[VersionedMessage(20601)]
public class LeagueStatsMessage : VersionedMessage
{
    public int Division { get; set; }
    public int League { get; set; }

    public LeagueStatsMessage() : base(0)
    {
        this.Division = 0;
        this.League = 0;
    }

    public override void Destruct()
    {
        base.Destruct();

        this.Division = 0;
        this.League = 0;
    }

    public override void Encode()
    {
        base.Encode();

        this.ByteStream.WriteInt(this.Division);
        this.ByteStream.WriteInt(this.League);

        this.ByteStream.WriteInt(50);
        for (int i = 0; i < 50; i++)
        { 
            this.ByteStream.WriteInt(20486);

            this.ByteStream.WriteInt(i);
            this.ByteStream.WriteInt(i);

            this.ByteStream.WriteInt(20486);
            this.ByteStream.WriteInt(0);
            this.ByteStream.WriteInt(i);
            this.ByteStream.WriteString("t.me/BL4D3_BR34D");
            this.ByteStream.WriteString("" + i);
            this.ByteStream.WriteInt(21);
        }

        new LogicGameCalendar(20486).Encode(this.ByteStream);
    }

    public override void Decode()
    {
        base.Decode();
    }

    public override int GetServiceNodeType()
    {
        return 13;
    }

    public override int GetMessageType()
    {
        return 20601;
    }
}
