namespace Supercell.GUT.SDK;

internal static class Program
{
    private static async Task Main(string[] args)
    {
        Console.Title = "Supercell.GUT | SDK";

        WebApplicationBuilder builder = WebApplication.CreateBuilder(args);
        builder.WebHost.UseUrls("http://*:80");

        WebApplication app = builder.Build();

        app.MapGet("/fece25cfc941db1a5bb3e79d4e6a60c34659f49e/fingerprint.json", GetFingerprintJSON); // hardcode! maybe later i will fix it

        await app.RunAsync();
    }

    private static string GetFingerprintJSON(HttpContext context)
    {
        return "{\"files\":[{\"sha\":\"505f650e5cabad8f139687c3f9aa66712d883a40\",\"file\":\"data\\/about.csv\",\"checksum\":\"71befcab\"},{\"sha\":\"51fde1a650aa0b66333ad5b66f59b22e8e54c4e5\",\"file\":\"data\\/ai_units.csv\",\"checksum\":\"afc97037\"},{\"sha\":\"19d3b1573cbd3ed59ee337c89bc5f82e8f30c68a\",\"file\":\"data\\/avatar.csv\",\"checksum\":\"f2eb9b6b\"},{\"sha\":\"0482673d8a493c8903babaf4066985e26018b919\",\"file\":\"data\\/billing_packages.csv\",\"checksum\":\"ce55b6c9\"},{\"sha\":\"97b4e6e365c9c110f38e5d55871512b75ce4bc3a\",\"file\":\"data\\/credits.csv\",\"checksum\":\"32376eed\"},{\"sha\":\"3cc18120f0fd00e073ace85d9326f38ce93b1cd7\",\"file\":\"data\\/cutscene.csv\",\"checksum\":\"b36efeb1\"},{\"sha\":\"b4dea5cb966a9a55eb050bdcab3cc39c6108509e\",\"file\":\"data\\/gadget.csv\",\"checksum\":\"4576288d\"},{\"sha\":\"03a0a7661ef1024d668ab0c5485696b05ccc5092\",\"file\":\"data\\/game_const.csv\",\"checksum\":\"e11bbf82\"},{\"sha\":\"fafee2358474f289ddefb241d6c8337908dc8168\",\"file\":\"data\\/gamelevel.csv\",\"checksum\":\"995dbb23\"},{\"sha\":\"a633224eee7bccb4ad0b10945694d7a70c5ad93d\",\"file\":\"data\\/gui.csv\",\"checksum\":\"27230b9d\"},{\"sha\":\"dee03d769deb41f0d823a77b8f95deccd5892fba\",\"file\":\"data\\/handbook.csv\",\"checksum\":\"e489859a\"},{\"sha\":\"ebe15e0d095677a16a3a2f466ce5cc8dd1972931\",\"file\":\"data\\/inboxmessage.csv\",\"checksum\":\"2fef1fae\"},{\"sha\":\"c0d921b74e476ea85470dfe97ca5de0b498764f6\",\"file\":\"data\\/item.csv\",\"checksum\":\"9ae439cd\"},{\"sha\":\"1e8b8532d5b6f2f9c129e6870f3b4529bb926479\",\"file\":\"data\\/lang.csv\",\"checksum\":\"b0acc094\"},{\"sha\":\"91e08d3857aab5ecceda43f9ae6b1d25def92f7c\",\"file\":\"data\\/leagues.csv\",\"checksum\":\"a448bd6e\"},{\"sha\":\"84b7125afd12c834e98ba0fd7eda3ba3c76246d7\",\"file\":\"data\\/level.csv\",\"checksum\":\"359e1925\"},{\"sha\":\"fe2aec13f1855e01ef6f8b255f0e7bf48cb58179\",\"file\":\"data\\/mission.csv\",\"checksum\":\"368649a8\"},{\"sha\":\"551df4fb20dba5a20e9281e50682d03f99859c9e\",\"file\":\"data\\/mission_tree.csv\",\"checksum\":\"55276023\"},{\"sha\":\"ae3ff2b07fcf5cef9a0f642c2ce6eae6ac00f0cd\",\"file\":\"data\\/moneybag.csv\",\"checksum\":\"29c04cff\"},{\"sha\":\"a8e4643f7157624432b6066e4d09d3722c40c4f3\",\"file\":\"data\\/readingtimes.csv\",\"checksum\":\"1e7bdc9b\"},{\"sha\":\"953289348875f3d8f6502d6cc1f60ea333841f8a\",\"file\":\"data\\/shop.csv\",\"checksum\":\"20449e2e\"},{\"sha\":\"a0f879b889aa8a25dcf03bf2d2bde85d9544600e\",\"file\":\"data\\/skill.csv\",\"checksum\":\"61288ccd\"},{\"sha\":\"e4c8e78e8aa71b70feb8c0959fd4c9a7e183bfbd\",\"file\":\"data\\/sounds.csv\",\"checksum\":\"195e7e52\"},{\"sha\":\"20495a2034755d8042016965ccea119f2efb173d\",\"file\":\"data\\/sounds_ipad1.csv\",\"checksum\":\"1531642f\"},{\"sha\":\"3b5047a6c8fab85bb8b0b313b8faabd61151bea1\",\"file\":\"data\\/speedup.csv\",\"checksum\":\"c96ef3ea\"},{\"sha\":\"1388ecfea65b98d1e9e4be785dac1a8a5964df57\",\"file\":\"data\\/trainingtimes.csv\",\"checksum\":\"811f4bd1\"},{\"sha\":\"a3055faddd0a1eff4f4da59df958235e3e5521c9\",\"file\":\"data\\/unit.csv\",\"checksum\":\"3c1ba78c\"},{\"sha\":\"6d37f4b27604df00c356e6776c6639b2e06a3669\",\"file\":\"data\\/upgrade.csv\",\"checksum\":\"e5f57998\"},{\"sha\":\"de893824bdf5e43ac377b276520ec65f399bb987\",\"file\":\"data\\/weapon.csv\",\"checksum\":\"a3079a59\"},{\"sha\":\"828dc22a8256dc0ffbc790983ad6a535221fe01d\",\"file\":\"gut.ini\",\"checksum\":\"601b736\"},{\"sha\":\"828dc22a8256dc0ffbc790983ad6a535221fe01d\",\"file\":\"gut_ipad2.ini\",\"checksum\":\"601b736\"},{\"sha\":\"828dc22a8256dc0ffbc790983ad6a535221fe01d\",\"file\":\"gut_ipad3.ini\",\"checksum\":\"601b736\"},{\"sha\":\"0d643a9c5bf2b8be58ba76cc0b3d25d84618a305\",\"file\":\"gut_iphone3.ini\",\"checksum\":\"5e8a6d2c\"},{\"sha\":\"0d643a9c5bf2b8be58ba76cc0b3d25d84618a305\",\"file\":\"gut_iphone4.ini\",\"checksum\":\"5e8a6d2c\"}],\"sha\":\"fece25cfc941db1a5bb3e79d4e6a60c34659f49e\"}\r\n";
    }
}
