﻿using Supercell.GUT.Titan.Logic.Message;

namespace Supercell.GUT.Server.Network.Connection;
internal interface IConnectionListener
{
    public delegate ValueTask SendCallback(Memory<byte> buffer);
    public delegate Task ReceiveCallback(PiranhaMessage message);

    SendCallback OnSend { set; }
    ReceiveCallback RecvCallback { set; }

    ValueTask<int> OnReceive(Memory<byte> buffer, int size);

    Task Send(PiranhaMessage message);

    void InitEncryption(string key, string nonce);
}
