﻿using Microsoft.Extensions.Logging;
using Supercell.GUT.Logic.Message.Account;
using Supercell.GUT.Server.Network.Connection;
using Supercell.GUT.Server.Protocol.Attributes;

namespace Supercell.GUT.Server.Protocol.Handlers;

[ServiceNode(13)]
internal class LeagueMesageHandler : MessageHandlerBase
{
    private readonly ILogger _logger;
    private readonly ClientConnection _connection;

    public LeagueMesageHandler(ClientConnection connection, ILogger<LeagueMesageHandler> logger)
    {
        _logger = logger;
        _connection = connection;
    }
    
    [MessageHandler(10601)]
    public async Task OnAskForLeagueStats(AskForLeagueStatsMessage askForLeagueStatsMessage)
    {
        await _connection.SendMessage(new LeagueStatsMessage()
        {
            Division = 1,
            League = 0,
        });
    }
}
