﻿using Supercell.GUT.Titan.Logic.DataStream;

namespace Supercell.GUT.Titan.Logic.Message;

public abstract class PiranhaMessage
{
    public ByteStream ByteStream { get; }

    public int MessageVersion { get; set; } 

    public PiranhaMessage(int messageVersion)
    {
        this.ByteStream = new ByteStream();
        this.MessageVersion = messageVersion;
    }

    public virtual void Encode()
    {
        ;
    }

    public virtual void Decode()
    {
        ;
    }

    public abstract int GetServiceNodeType();
    public abstract int GetMessageType();
    
    public int GetEncodingLength()
    {
        return this.ByteStream.Length;
    }

    public virtual void Destruct()
    {
        this.ByteStream.Destruct();
        this.MessageVersion = 0;
    }
}
